﻿function LockNotes_SlashCommandHandler( msg )
    LockNotes_Frame1:Show();
    nightfallCheckbox:SetChecked(nightfallEnabled);
    buffsCheckbox:SetChecked(enemyBuffsEnabled);
    targetOnlyCheckbox:SetChecked(targetAndFocusOnly);
    targetChangeUpdateCheckbox:SetChecked(targetChangeUpdate);
    if (targetOnlyCheckbox:GetChecked()) then
        targetChangeUpdateCheckbox:Enable();
    else
        targetChangeUpdateCheckbox:Disable();
    end
    missesCheckbox:SetChecked(resistsEnabled);
    meleeNoisesCheckBox:SetChecked(meleeNoisesEnabled);
    if (buffsCheckbox:GetChecked()) then
        targetOnlyCheckbox:Enable();
    else
        targetOnlyCheckbox:Disable();
    end
    eradicationButton:SetChecked(eradicationEnabled);
end
----------------------------------------------------------------Button Functions----------------------------------------------------------------
function LockNotes_cancelButton_OnClick()   --------CANCEL BUTTON
    LockNotes_Frame1:Hide();
end

function LockNotes_okButton_OnClick()   -------OK BUTTON

------------------------------------------------------check if checkboxes checked---------------------------
    nightfallEnabled = nightfallCheckbox:GetChecked();
    enemyBuffsEnabled = buffsCheckbox:GetChecked();
    targetAndFocusOnly = targetOnlyCheckbox:GetChecked();
    if(enemyBuffsEnabled~=1) then
        targetAndFocusOnly = nil;
    end
    targetChangeUpdate = targetChangeUpdateCheckbox:GetChecked();
    if(targetAndFocusOnly==nil) then
        targetChangeUpdate = nil;
    end
    resistsEnabled = missesCheckbox:GetChecked();
    meleeNoisesEnabled = meleeNoisesCheckBox:GetChecked();
    eradicationEnabled = eradicationButton:GetChecked();
--------------------------------set nils to false for saved variable purposes---------------------

    if (not nightfallEnabled) then
        nightfallEnabled = false;
    end
    if (not enemyBuffsEnabled) then
        enemyBuffsEnabled = false;
    end
    if (not targetAndFocusOnly) then
        targetAndFocusOnly = false;
    end
    if (not targetChangeUpdate) then
        targetChangeUpdate = false;
    end
    if (not resistsEnabled) then
        resistsEnabled = false;
    end
    if (not meleeNoisesEnabled) then
        meleeNoisesEnabled = false;
    end
    if (not eradicationEnabled) then
        eradicationEnabled = false;
    end
    LockNotes_Frame1:Hide();
    if(not targetChangeUpdate) then
        LockNotesFrame:UnregisterEvent("PLAYER_TARGET_CHANGED");
        LockNotesFrame:UnregisterEvent("PLAYER_FOCUS_CHANGED");
    else
        LockNotesFrame:RegisterEvent("PLAYER_TARGET_CHANGED");
        LockNotesFrame:RegisterEvent("PLAYER_FOCUS_CHANGED");
    end
end

function targetOnlyCheckbox_OnClick()  ------TARGETONLYCHECKBOX CLICK
    if(targetOnlyCheckbox:GetChecked() and targetOnlyCheckbox:IsEnabled()) then
        targetChangeUpdateCheckbox:Enable();
    else
        targetChangeUpdateCheckbox:Disable();
    end
end

function buffsCheckbox_OnClick()     -------BUFFS CHECKBOX CLICK
    if (buffsCheckbox:GetChecked()) then -- disable target/focus only checkbox if buffs are turned off
        targetOnlyCheckbox:Enable();
		if(targetOnlyCheckbox:GetChecked()) then
			targetChangeUpdateCheckbox:Enable();
		end
    else
        targetOnlyCheckbox:Disable();
        targetChangeUpdateCheckbox:Disable();
    end
end

----------------------------------------------------------------On Load-------------------------------------------------------------------------

function LockNotes_OnLoad(this)
    this:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
    this:RegisterEvent("PLAYER_TARGET_CHANGED");
    this:RegisterEvent("PLAYER_FOCUS_CHANGED");
    this:RegisterEvent("ADDON_LOADED");
    MySpellReflected = 1;

------------------------------------initialize savedvariables on first startup-------------------------------
    if(nightfallEnabled==nil) then
        nightfallEnabled=true;
    end
    if(enemyBuffsEnabled==nil) then
        enemyBuffsEnabled=true;
    end
    if(targetAndFocusOnly==nil) then
        targetAndFocusOnly=false;
    end
    if(targetChangeUpdate==nil) then
        targetChangeUpdate=false;
    end
    if(resistsEnabled==nil) then
        resistsEnabled=true;
    end
    if(meleeNoisesEnabled==nil) then
        meleeNoisesEnabled=true;
    end
    if(eradicationEnabled==nil) then
        eradicationEnabled=true;
    end
---------------------------------end initialization of saved variables, begin slash commands--------------------------------------

    SlashCmdList["LOCKNOTES"] = LockNotes_SlashCommandHandler; -- Add slash command handler to the list of slash commands
    SLASH_LOCKNOTES1 = "/locknotes"; -- Associate /locknotes with the slash command list entry for LOCKNOTES
    SLASH_LOCKNOTES2 = "/ln"; -- Associate /ln with the slash command list entry for LOCKNOTES
end

function LockNotes_OnEventTargetChange(self, event)
    if (UnitIsEnemy("player","target")) then
        local i = 1;
        local buffNOTNil = true;
        while (i <=40 and buffNOTNil) do local _,_,_,_,_,_,_,_,_,_,spellID=UnitBuff("target",i);   
            i=i+1;
            buffNOTNil = spellID;
            if ((spellID == 31224)    -- Cloak of Shadows
                or (spellID == 642)   -- Divine Shield
                or (spellID == 47585) -- Disperson
                or (spellID == 23920) -- Spell Reflect
                or (spellID == 48707) -- Anti Magic Shell
                or (spellID == 45438) -- IceBlock
                or (spellID == 19263) -- Deterrence
                or (spellID == 49039) -- LichBorne
                or (spellID == 18499) -- Berserker Rage
                or (spellID == 6346)  -- Fear Ward
                or (spellID == 1719)  -- Recklessness
                or (spellID == 89485)  -- Inner Focus
                or (spellID == 31821)) then -- Concentration Aura
                local spellName,_,_,_,_,_,_,_,_ = GetSpellInfo(spellID);
                ZoneTextString:SetText(""..spellName.." up! (TAR)");
			    ZoneTextFrame.startTime = GetTime()
			    ZoneTextFrame.fadeInTime = 0
			    ZoneTextFrame.holdTime = 1
			    ZoneTextFrame.fadeOutTime = 2
			    ZoneTextString:SetTextColor(1, 0, 0);
			    PVPInfoTextString:SetText("");
			    ZoneTextFrame:Show()
			    if (spellID == 89485) or (spellID == 31821) then -- Conc aura and inner focus, uninterruptable heals
				    PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\bird_flap.ogg");
			    elseif (spellID == 49039) or (spellID == 1719) or (spellID == 18499) or (spellID == 6346) then -- Lichborne, recklessness, zerker rage, and fear ward, just unfearable
				    PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\buzz.ogg");			
			    else
				    PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\pulse.ogg"); -- for all pure magic immunities
			    end
			    if (spellID == 23920) then
			        MySpellReflected = false;
			    end
            end    
        end
    end
end

function LockNotes_OnEventFocusChange(self, event)
    if (UnitIsEnemy("player","focus")) then
        local i = 1;
        local buffNOTNil = true;
        while (i <=40 and buffNOTNil) do local _,_,_,_,_,_,_,_,_,_,spellID=UnitBuff("focus",i);   
            i=i+1;
            buffNOTNil = spellID;
            if ((spellID == 31224)    -- Cloak of Shadows
                or (spellID == 642)   -- Divine Shield
                or (spellID == 47585) -- Disperson
                or (spellID == 23920) -- Spell Reflect
                or (spellID == 48707) -- Anti Magic Shell
                or (spellID == 45438) -- IceBlock
                or (spellID == 19263) -- Deterrence
                or (spellID == 49039) -- LichBorne
                or (spellID == 18499) -- Berserker Rage
                or (spellID == 6346)  -- Fear Ward
                or (spellID == 1719)  -- Recklessness
                or (spellID == 89485)  -- Inner Focus
                or (spellID == 31821)) then -- Concentration Aura
                local spellName,_,_,_,_,_,_,_,_ = GetSpellInfo(spellID);
                ZoneTextString:SetText(""..spellName.." up! (foc)");
			    ZoneTextFrame.startTime = GetTime()
			    ZoneTextFrame.fadeInTime = 0
			    ZoneTextFrame.holdTime = 1
			    ZoneTextFrame.fadeOutTime = 2
			    ZoneTextString:SetTextColor(1, 0, 0);
			    PVPInfoTextString:SetText("");
			    ZoneTextFrame:Show()
			    if (spellID == 89485) or (spellID == 31821) then -- Conc aura and inner focus, uninterruptable heals
				    PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\bird_flap.ogg");
			    elseif (spellID == 49039) or (spellID == 1719) or (spellID == 18499) or (spellID == 6346) then -- Lichborne, recklessness, zerker rage, and fear ward, just unfearable
				    PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\buzz.ogg");			
			    else
				    PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\pulse.ogg"); -- for all pure magic immunities
			    end
			    if (spellID == 23920) then
			        MySpellReflected = false;
			    end
            end    
        end
    end
end

function LockNotes_UnRegisterNonCheckedEvents()
    if(not targetChangeUpdate) then
        LockNotesFrame:UnregisterEvent("PLAYER_TARGET_CHANGED");
        LockNotesFrame:UnregisterEvent("PLAYER_FOCUS_CHANGED");
    end
end

function LockNotes_EventHandler(self, event, ...)
    if(event=="COMBAT_LOG_EVENT_UNFILTERED") then
        LockNotes_CombatLogEvent(self, event, ...);
    elseif(event=="PLAYER_TARGET_CHANGED") then
        LockNotes_OnEventTargetChange(self, event);
    elseif(event=="PLAYER_FOCUS_CHANGED") then
        LockNotes_OnEventFocusChange(self, event);
    else
        LockNotes_UnRegisterNonCheckedEvents();
    end   
end


function LockNotes_CombatLogEvent(self, event, timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellID, spellName, arg11, arg12, arg13)
local eventRegistered = {["SPELL_AURA_APPLIED"] = true, ["SPELL_AURA_REFRESH"] = true, ["SPELL_AURA_REMOVED"] = true, ["SPELL_CAST_SUCCESS"] = true, ["SPELL_MISSED"] = true};
if( not eventRegistered[eventType] ) then
    return
end

------------------------------------------------------------- Friendly Buffs -------------------------------------------------------------


-- Shadow Trance/BackSlash/empowered imp and eradication/molten core/decimation
if (eventType == "SPELL_AURA_APPLIED" or eventType == "SPELL_AURA_REFRESH") then
	if bit.band(destFlags, COMBATLOG_OBJECT_AFFILIATION_MINE) > 0 then
        local spellHit = false;
        if (spellID == 17941) and nightfallEnabled then  -- nightfall proc
			ZoneTextString:SetText("Shadow Bolt!");
            ZoneTextString:SetTextColor(1, 0, 1);
            PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\ding.ogg");
            spellHit = true;
        elseif ((spellID == 34936) or (spellID == 34938) or (spellID == 34939) and nightfallEnabled) then  -- backlash proc
            ZoneTextString:SetText("Incinerate!");
            ZoneTextString:SetTextColor(1, 0.5, 0);
            PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\ding.ogg");
            spellHit = true;
        elseif (spellID == 47283) and nightfallEnabled then  -- empowered imp proc
            ZoneTextString:SetText("Soul Fire!");
            ZoneTextString:SetTextColor(1, 0.5, 0);
            PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\ding.ogg");
            spellHit = true;
        elseif ((spellID == 64371) or (spellID == 71165) or (spellID == 63167)) and eradicationEnabled then  -- eradication/molten core/decimation
			ZoneTextString:SetText(""..spellName.." up!");
            if (spellID == 64371) then
				ZoneTextString:SetTextColor(0, 1, 0);
			else
				ZoneTextString:SetTextColor(1, 0.5, 0);
			end
            spellHit = true;
            PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\bell.ogg");
        end
        if (spellHit) then -- if it registered and was caught, display the notice on the screen
    		ZoneTextFrame.startTime = GetTime()
	    	ZoneTextFrame.fadeInTime = 0
	    	ZoneTextFrame.holdTime = 1
		    ZoneTextFrame.fadeOutTime = 2
		    PVPInfoTextString:SetText("");
		    ZoneTextFrame:Show()
        end
    end


------------------------------------------------------------------------------------------------------------------------------------------


------------------------------------------------------------- Hostile Spells -------------------------------------------------------------
elseif (eventType == "SPELL_CAST_SUCCESS") then
	if (meleeNoisesEnabled and 
        ((spellID == 6552) -- Pummel
     or (spellID == 96231) --  Rebuke
     or (spellID == 1766) --  Kick
     or (spellID == 80964) --  Skull Bash Bear (might not be needed, it's pretty loud already, but just for consistancy)
     or (spellID == 80965) --  Skull Bash Cat
     or (spellID == 47528))) then  --  Mind Freeze
		if (destName==UnitName("player")) then
			PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\gun_fire.ogg");	
		end
	end	

		
	if  bit.band(sourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 and enemyBuffsEnabled then -- Makes sure it's an enemy player    
		if  (spellID == 31224)    -- Cloak of Shadows
            or (spellID == 642)   -- Divine Shield
            or (spellID == 47585) -- Disperson
            or (spellID == 23920) -- Spell Reflect
            or (spellID == 48707) -- Anti Magic Shell
            or (spellID == 45438) -- IceBlock
            or (spellID == 19263) -- Deterrence
            or (spellID == 49039) -- LichBorne
            or (spellID == 18499) -- Berserker Rage
            or (spellID == 6346)  -- Fear Ward
            or (spellID == 1719)  -- Recklessness
            or (spellID == 89485)  -- Inner Focus
            or (spellID == 31821) then -- Concentration Aura
			local target = UnitGUID("target") -- aquire the player's target
			local focus = UnitGUID("focus")  -- aquire the player's focus
            if (targetAndFocusOnly and (sourceGUID==target or sourceGUID==focus)) then  -- if target and focus only is chosen and source is either target or focus
			    if (sourceGUID==target) then  -- if source is target then...
					ZoneTextString:SetText(""..spellName.." up! (TAR)");
					ZoneTextFrame.startTime = GetTime()
					ZoneTextFrame.fadeInTime = 0
					ZoneTextFrame.holdTime = 1
					ZoneTextFrame.fadeOutTime = 2
					ZoneTextString:SetTextColor(1, 0, 0);
					PVPInfoTextString:SetText("");
					ZoneTextFrame:Show()
					if (spellID == 89485) or (spellID == 31821) then -- Conc aura and inner focus, uninterruptable heals
						PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\bird_flap.ogg");
					elseif (spellID == 49039) or (spellID == 1719) or (spellID == 18499) or (spellID == 6346) then -- Lichborne, recklessness, zerker rage, and fear ward, just unfearable
						PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\buzz.ogg");			
					else
						PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\pulse.ogg"); -- for all pure magic immunities
					end
					if (spellID == 23920) then
					MySpellReflected = false;
					end
				elseif(sourceGUID==focus) then -- if source isn't target but is focus then...
					ZoneTextString:SetText(""..spellName.." up! (foc)");
					ZoneTextFrame.startTime = GetTime()
					ZoneTextFrame.fadeInTime = 0
					ZoneTextFrame.holdTime = 1
					ZoneTextFrame.fadeOutTime = 2
					ZoneTextString:SetTextColor(1, 0, 0);
					PVPInfoTextString:SetText("");
					ZoneTextFrame:Show()
					if (spellID == 89485) or (spellID == 31821) then -- Conc aura and inner focus, uninterruptable heals
						PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\bird_flap.ogg");
					elseif (spellID == 49039) or (spellID == 1719) or (spellID == 18499) or (spellID == 6346) then -- Lichborne, recklessness, zerker rage, and fear ward, just unfearable
						PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\buzz.ogg");			
					else
						PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\pulse.ogg"); -- for all pure magic immunities
					end
					if (spellID == 23920) then
					MySpellReflected = false;					
					end
				end
			elseif(not targetAndFocusOnly) then  -- if target and focus only isn't checkmarked, ready the spam
				ZoneTextString:SetText(""..spellName.." up! ");
				ZoneTextFrame.startTime = GetTime()
				ZoneTextFrame.fadeInTime = 0
				ZoneTextFrame.holdTime = 1
				ZoneTextFrame.fadeOutTime = 2
				ZoneTextString:SetTextColor(1, 0, 0);
				PVPInfoTextString:SetText("");
				ZoneTextFrame:Show()
				if (spellID == 89485) or (spellID == 31821) then
					PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\bird_flap.ogg"); -- Conc aura and inner focus, uninterruptable heals
				elseif (spellID == 49039) or (spellID == 1719) or (spellID == 18499) or (spellID == 6346) then  -- Lichborne, recklessness, zerker rage, and fear ward, just unfearable
					PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\buzz.ogg");			
				else
					PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\pulse.ogg"); -- for all pure magic immunities
				end
				if (spellID == 23920) then
				MySpellReflected = false;
				end
				
			end
		end
	end


elseif (eventType == "SPELL_AURA_REMOVED" and enemyBuffsEnabled) then
	if bit.band(destFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 then
        local target = UnitGUID("target")
		local focus = UnitGUID("focus")
		if (spellID == 31224)    -- Cloak of Shadows
            or (spellID == 642)   -- Divine Shield
            or (spellID == 47585) -- Disperson
            or (spellID == 23920) -- Spell Reflect
            or (spellID == 48707) -- Anti Magic Shell
            or (spellID == 45438) -- IceBlock
            or (spellID == 19263) -- Deterrence
            or (spellID == 49039) -- LichBorne
            or (spellID == 18499) -- Berserker Rage
            or (spellID == 6346)  -- Fear Ward
            or (spellID == 1719)  -- Recklessness
            or (spellID == 89485)  -- Inner Focus
            or (spellID == 31821) then -- Concentration Aura
			if ((targetAndFocusOnly and (sourceGUID==target or sourceGUID==focus)) or (not targetAndFocusOnly)) then -- if target and focus only is checked and source is target or focus OR if target and focus is not checked
				ZoneTextString:SetText(""..spellName.." down.");
				ZoneTextFrame.startTime = GetTime()
				ZoneTextFrame.fadeInTime = 0
				ZoneTextFrame.holdTime = 1
				ZoneTextFrame.fadeOutTime = 2
				ZoneTextString:SetTextColor(0, 1, 0);
				PVPInfoTextString:SetText("");
				ZoneTextFrame:Show()
			end
        elseif (spellID == 23920) then
			if ((targetAndFocusOnly and (sourceGUID==target or sourceGUID==focus)) or (not targetAndFocusOnly)) then
				if (not MySpellReflected) then
					ZoneTextString:SetText(""..spellName.." down.");
					ZoneTextFrame.startTime = GetTime()
					ZoneTextFrame.fadeInTime = 0
					ZoneTextFrame.holdTime = 1
					ZoneTextFrame.fadeOutTime = 2
					ZoneTextString:SetTextColor(0, 1, 0);
					PVPInfoTextString:SetText("");
					ZoneTextFrame:Show()
				end
            end
		end
	end


------------------------------------------------------------------------------------------------------------------------------------------


------------------------------------------------------------- Other ----------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------


------------------------------------------------------------- Resists --------------------------------------------------------------------
elseif (resistsEnabled) then--if (eventType == "SPELL_MISSED") then -- need to add: evade, deflect (what is this?), check what happens when debuff is on an evading mob, dont want spam for each dot tick, even tho most evades remove all debuffs on them, not all
	if bit.band(sourceFlags, COMBATLOG_OBJECT_AFFILIATION_MINE) > 0 then -- Makes sure it's my own spell or my pet's spell
		if (spellID == 172) or (spellID == 6789) or (spellID == 1714) or (spellID == 702) or (spellID == 5782) or (spellID == 980) or (spellID == 689) or (spellID == 86213) or (spellID == 77799) then
			if (destName == "Grounding Totem") or (destName == "Тотем заземления") then
				ResistMethod = "Grounded"
			elseif (arg12 == "REFLECT") then
				ResistMethod = "reflected"
				MySpellReflected = true;
			elseif (arg12 == "IMMUNE") then
				ResistMethod = "failed"
			else
				ResistMethod = "resisted"
			end
			if (arg12 ~= "ABSORB") then
				ZoneTextString:SetText(""..spellName.." "..ResistMethod..".");
				ZoneTextFrame.startTime = GetTime()
				ZoneTextFrame.fadeInTime = 0
				ZoneTextFrame.holdTime = 1
				ZoneTextFrame.fadeOutTime = 2
				ZoneTextString:SetTextColor(1, 1, 1);
				PVPInfoTextString:SetText("");
				ZoneTextFrame:Show()
					if (ResistMethod ~= "failed") then -- only play sound file when you need to instantly recast what you just casted
						PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\cling.ogg");
					end
			end	
		end
	end
end
------------------------------------------------------------------------------------------------------------------------------------------
end
